import math
import sys

def patio(file, N):
    count = 0
    for i in range(len(file) - 8):
        count += count_subs(file, N, i)
    return count

def count_subs(file, N, i):
    count = 0
    blue = 0
    red = 0
    for i in range(i, len(file)):
        if file[i] == 'X':
            red+=1
        if file[i] == 'O':
            blue+=1
        B = max(blue, red)
        F = min(blue, red)
        if (B == (math.sqrt(F)+2)**2 - F) or (F == (math.sqrt(B)+2)**2 - B):
            count+=1
        #print(red)
        #print(blue)
    return count

if __name__ == '__main__':
    N = int(input())
    file = sys.stdin.readline().strip("\n")
    #print(N)
    #print(file)
    print(patio(file, N))