import sys


if __name__ == '__main__':
    N, M, F, T, S = [int(c) for c in sys.stdin.readline().strip("\n").split()]

    if S == F:
        print(0)
        exit(0)

    neighbours = dict()
    for _ in range(M):
        a, b = [int(c) for c in sys.stdin.readline().strip("\n").split()]
        if a in neighbours:
            neighbours[a].append(b)
        else:
            neighbours[a] = [b]
        if b in neighbours:
            neighbours[b].append(a)
        else:
            neighbours[b] = [a]
    our = {S}
    enemy = {T}
    nights = 0
    while True:
        nights += 1
        tmp_enemy = set()
        for e in enemy:
            for n in neighbours[e]:
                tmp_enemy.add(n)
        enemy = tmp_enemy
        tmp_our = set()
        for o in our:
            if o not in enemy:
                tmp_our.add(o)
            for n in neighbours[o]:
                if n not in enemy:
                    tmp_our.add(n)
        our = tmp_our

        if F in our:
            print(nights)
            break

        if len(our) == 0:
            print("death")
            break
